
/*----------------------------------------------------------------------------
 *  Copyright (c) 1991, 1992, 1993, 1994   Ohio University
 *                                         Accelerator Laboratory
 *
 *  This software was partially developed under a United States Government
 *  license described in the Notice file included as part of this distribution
 *
 *    Ohio University Accelerator Laboratory, Athens, Ohio  45701
 *
 *    carter@oual3.phy.ohiou.edu   Tel: (614) 593-1984  Fax: (614) 593-1436
 *    odonnell@oual3.phy.ohiou.edu Tel: (614) 593-1977  Fax: (614) 593-1436
 *----------------------------------------------------------------------------
 *
 * Authors:
 *
 *	Don Carter
 *      John O'Donnell
 *
 *	Ohio University Accelerator Laboratory
 *
 * Original version DAQ created 1991
 * Revision History:
 *
 *----------------------------------------------------------------------------*/

/* Command processing routine for the PC data acquisition system */
  
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <oual.h>
#include <conio.h>

/* following added to support shared memory  d.carter*/

#include <sys/types.h> 
#include <sys/ipc.h>
// #include <sys/shm.h> 

extern char oual_vars[5][20][16];
extern int oual_atype[5][20];
extern char pname[80];
extern int ptype;
extern int id;
extern int oual_ioperm;

int oual_abort = 0,oual_sub_index = -1, oual_sub_count = 0;
unsigned *oual_sub_ptr;
int oual_at_EOF = 1;
int IPL_flag = 0;

	char dosbuf[133];

command_proc(iunit,ounit)
	FILE *iunit, *ounit;
{
	auto char fname[13],save_nest_name[9];

	int more,cmnd_nmbr;
	int param,ch;
	FILE *save_iunit, *save_ounit;
	oual_iunit = iunit;
	oual_ounit = ounit;

	more = 1;
	cmnd_nmbr = 1;
        
        
	// check in current directory for autoexec.daq
	if(IPL_flag == 0)
	  {
	  IPL_flag = 1;
	  strcpy(fname,"IPL.daq");
	  if ((iunit = fopen(fname,"r")) != NULL)
		{
		// goto daqlocal;
		fprintf(ounit,"daq>(%s)",fname);
		save_iunit = oual_iunit;
		save_ounit = oual_ounit;
		//oual_nest_level++;
		strcpy(save_nest_name,oual_nest_name);
		strcpy(oual_nest_name,oual_cmnd);
		goto noparams;
		}
	  }

	if ((oual_nest_level > 0) && (oual_verbose > 0)) fprintf(ounit,"\n[%d;%s(%d)]: ",oual_nest_level,
									oual_nest_name,cmnd_nmbr);
	while ( more ) {

	outerloop:
                 
                 fflush(stdout);
                 if(oual_ioperm)
                 {
                 term_character();
                 while((oual_nest_level == 0)
			  &&(oual_sub_count <= 1)
			  &&(kbhit1() == 0)
			  &&(oual_at_EOF == 1)
			  &&(oual_plot_flag == 0)
			  &&(oual_terminate == 0)
                          &&(((inportb(0x312) ^ 0xff) >> 2) == 0))
				{
                                daqtimer();
                                /* 
                                   the following added so that we don't
                                   clobber the interrupt call too heavily
                                   in daqtimer()  /d.e.carter
                                */
                                usleep(10000); /* force interrupt check every 10 ms. */
                                }
                 if((kbhit1() == 1) && (oual_nest_level == 0))
                   {
                   //ch=getchar();
                   ch=getc(stdin);
                   term_line();
                   ungetc(ch,stdin);
                   }        
                 
                 else term_line();
        
                 }       
                fflush(stdout);
//		while((oual_nest_level == 0)&&(kbhit1() == 0)&&(((inportb(0x312) ^ 0xff) >> 2) == 0)) daqtimer();
//		printf("\n after daqtimer call");

        innerloop:

		if(oual_intmask == 0)
			{
			if(oual_terminate == 1)
				{
				strcpy (oual_cmnd,"DONE");
				intstate(0);
				oual_intmask = 1;
				//oual_terminate = 0;
				goto sofint;
				}
			oual_sofint=((inportb(0x312) ^ 0xff) >> 2);
			if (oual_sofint != 0)
				{
				strcpy (oual_cmnd,"INT?");
				if(oual_sofint &  1) 	strcpy (oual_cmnd,"INT0");
				if(oual_sofint &  2) 	strcpy (oual_cmnd,"INT1");
				if(oual_sofint &  4) 	strcpy (oual_cmnd,"INT2");
				if(oual_sofint &  8) 	strcpy (oual_cmnd,"INT3");
				if(oual_sofint & 16) 	strcpy (oual_cmnd,"INT4");
				if(oual_sofint & 32) 	strcpy (oual_cmnd,"INT5");
				intstate(0);
				oual_intmask = 1;
				goto sofint;
				}
			}

		if((oual_plot_flag == 1) && (oual_nest_level == 0))
			{
			plot();
			goto plot_fake_nl;
			}

		rcmd_get_array:
		switch (gettoken(oual_cmnd)) {

			case T_WORD:

			sofint:
				oual_at_EOF = 0;

				/* inc command number unless in learn expansion */
				if (oual_sub_count <= 1) cmnd_nmbr++;

				/* Alter rump parameter values if file type is 5 (RUMP) */
                                if((oual_terminate == 0) && (oual_define[oual_sub_index].type == 5 ))
                                	rump();
                                else if ((strcmp(oual_cmnd,"exit")    == 0) ||
                                    (strcmp(oual_cmnd,"daqexit") == 0) ||
                                    (strcmp(oual_cmnd,"exitdaq") == 0))    
                                        {
					databufferptr = (struct databuffer *) shmptr;
                                        /* databufferptr->abort = 1; */
                                        /* while(databufferptr->abort != 2){} */
                                        freeram();
                                        /* intstate(0); */
					more = 0;
                                        /* exit(0); */
                                        /* return(0); */
                                        /* break; */
				        
                                        printf("\ndaqlinux aborting\n");
                                        if(databufferptr->abort == 2) goto alreadyexited;
                                        databufferptr->abort = 1; /* request child to exit */
		
                        	waitforchild:
                                   	if (databufferptr->abort != 2) goto waitforchild;

                        	/* detach the shared memory segment from the process data space */

                        	alreadyexited:
                                   	printf("\n ready to detatch shared mem\n");
                                        if (shmdt(shmptr) == -1)
                                           {
                                           printf("\nshmdt detach shared memory failed\n");
                                           }
                                        else    
                                           {       
                                           printf("\nshared memory detached\n");
                                           }

                        	/* remove the shared memory segment */

                                	printf("\n ready to release sharred memory\n");
                                        if (shmctl(id, IPC_RMID, 0) == -1) 
                                           {
                                           printf("\nshmctl release shared memory failed.\n");
                                           exit(1);
                                           }
                                        else
                                           {
                                           printf("\nshared memory released\n");
                                           }
                                	term_restore();
                                        exit(0); 
                                        }
				else if (strcmp(oual_cmnd,"{") == 0); // ignore braces
				else if (strcmp(oual_cmnd,"}") == 0);
				else if (strcmp(oual_cmnd,"rcmd") == 0) goto rcmd_get_array;  // dummy entry rcmd
				else if (strcmp(oual_cmnd,"a") == 0) intstate(1);
				else if (strcmp(oual_cmnd,"s") == 0) intstate(0);
                                else if (strcmp(oual_cmnd,"loadint") == 0) intstate(2);
                                else if (strcmp(oual_cmnd,"intload") == 0) intstate(2);
				else if (strcmp(oual_cmnd,"integrate") == 0) integrat();
                                else if (strcmp(oual_cmnd,"delete") == 0) delete();
				else if ((strcmp(oual_cmnd,"define") == 0) ||
					   (strcmp(oual_cmnd,  "def")) == 0) oual_retcode = define();
				else if (strcmp(oual_cmnd,"add") == 0) oual_retcode = add(0);
				else if (strcmp(oual_cmnd,"sub") == 0) oual_retcode = add(1);
				else if (strcmp(oual_cmnd,"drename") == 0) oual_retcode = drename();
				else if (strcmp(oual_cmnd,"disk") == 0) disk();
                                else if (strcmp(oual_cmnd,"cd") == 0) daqchdir();
				else if (strcmp(oual_cmnd,"q") == 0) query();
				else if (strcmp(oual_cmnd,"bplot") == 0) oual_retcode = plot();
				else if (strcmp(oual_cmnd,"xplot") == 0) oual_retcode = fpdc();
                                else if (strcmp(oual_cmnd,"plotx") == 0) oual_retcode = fpdc();
                                else if (strcmp(oual_cmnd,"plot") == 0) oual_retcode = fpdc();
                                else if (strcmp(oual_cmnd,"ttplot") == 0) oual_retcode = ttplot();
				else if (strcmp(oual_cmnd,"help") == 0) help();
				else if (strcmp(oual_cmnd,"save") == 0) oual_retcode = save();
				else if (strcmp(oual_cmnd,"get") == 0) oual_retcode = get();
				/* Read and write RUMP style file */
				else if (strcmp(oual_cmnd,"write") == 0) rumpwrite();
				else if (strcmp(oual_cmnd,"read") == 0) get();
				/**********************************/
				else if (strcmp(oual_cmnd,"dcopy") == 0) oual_retcode = dcopy();
				else if (strcmp(oual_cmnd,"learn") == 0) learn();
				else if (strcmp(oual_cmnd,"tag") == 0) oual_retcode = tag();
				else if (strcmp(oual_cmnd,"t0") == 0) oual_retcode = t0();
				else if (strcmp(oual_cmnd,"runfor") == 0) oual_retcode = runfor();
				else if (strcmp(oual_cmnd,"verbose") == 0) verbose();
				else if (strcmp(oual_cmnd, "gate") == 0) oual_retcode = gate();
				else if	(strcmp(oual_cmnd,"rgate") == 0) oual_retcode = rgate();
				else if (strcmp(oual_cmnd,"replay") == 0) replay();
                        //	else if (strcmp(oual_cmnd,"rayrep") == 0) rayrep();
                        //	else if (strcmp(oual_cmnd,"nisrep") == 0) nisrep();
                        //	else if (strcmp(oual_cmnd,"jackrep") == 0) jackrep();
                                else if ((strcmp(oual_cmnd,"vector") == 0) ||
					   (strcmp(oual_cmnd,    "v") == 0)) oual_retcode = vector();
				else if (strcmp(oual_cmnd,"clear") == 0) oual_retcode = clear();
				else if (strcmp(oual_cmnd,"prescale") == 0) oual_retcode = prescale();
				else if (strcmp(oual_cmnd,"runtime") == 0) oual_retcode = runtime();
				else if (strcmp(oual_cmnd,"cleartime") == 0) oual_retcode = cleartime();
        			else if (strcmp(oual_cmnd, "gonimove") == 0) oual_retcode = gonimove();
  				else if (strcmp(oual_cmnd, "goni") == 0) oual_retcode = gonicmd(oual_iunit,oual_ounit);
//                              else if ((strcmp(oual_cmnd, "goni") == 0) && (oual_anal == 0)) oual_retcode = gonicmd(oual_iunit,oual_ounit);
//				else if (strcmp(oual_cmnd,"load") == 0) oual_retcode = load();
				else if (strcmp(oual_cmnd,"rem") == 0) flush();
				else if (strcmp(oual_cmnd,"*label") == 0)
					{
					flush();
					if(oual_nest_level == 0) oual_at_EOF = 1;
					break;
					}

				else {


				/*	if (oual_anal == 1)
						{
						fprintf(ounit,
							"\nERROR(command): Acquisition in progress.");
						if(oual_nest_level == 0) oual_at_EOF = 1;
						break;
						}
                                */

					// check in local directory first for fname.daq
					strcpy(fname,oual_cmnd);
					strcat(fname,".daq");
                                        iunit = fopen(fname,"r");
                                        /*
                                        if (iunit == NULL)
                                          { 
                                          // if not in local directory, check in c:\daq\sys directory
                                          strcpy(fname,"/home/daq/sys/");
                                          strcat(fname,oual_cmnd);
                                          strcat(fname,".daq");
                                          iunit = fopen(fname,"r");
                                          }
                                        */
                                        if (iunit != NULL)
						{
						if(oual_nest_level == 0) fprintf(ounit,"DAQ>(%s)",fname);
						save_iunit = oual_iunit;
						save_ounit = oual_ounit;
                                                // following line uncommented 20mar2000 dec 
                                                //oual_nest_level++;
						
                                                strcpy(save_nest_name,oual_nest_name);
						strcpy(oual_nest_name,oual_cmnd);

						// get parameters

						// if doing software interrupt no parameters
						if ((oual_sofint != 0) || (oual_terminate == 1))
							{
							if(oual_sofint != 0) oual_sofint = 0;
							if(oual_terminate == 1) oual_terminate = 0;
							goto noparams;
							}

						for (param = 0; param < 19; param++)
							{
							ptype = gettoken(pname);
							if ((ptype != T_NL) && (ptype != T_EOF))
							   {
							   if(oual_nest_level < 4)
									{
									strcpy(oual_vars[oual_nest_level+1][param+1],pname);
									oual_atype[oual_nest_level+1][param+1] = ptype;
									}
							   else fprintf(oual_ounit,
									"\nERROR(Command): Recursion level exceeded(4).\n");
							   }
							else break;
							}
						itoa(param,pname,10);
						strcpy(oual_vars[oual_nest_level+1][0],pname);
						oual_atype[oual_nest_level+1][0] = T_INTEGER;
						oual_last_token = ptype;

						// now execute fn.daq

						noparams:
						oual_nest_level++;
						// oual_sofint = 0;  // reset the interrupt flag
						command_proc(iunit,ounit);

						oual_nest_level--;
						strcpy(oual_nest_name,save_nest_name);
						oual_iunit = save_iunit;
						oual_ounit = save_ounit;
						fclose(iunit);
						
                                                if ((oual_nest_level > 0) && (oual_verbose > 0)) {
							fprintf(ounit,"> returning to [%d;%s(%d)]",oual_nest_level,
							oual_nest_name,cmnd_nmbr);
							// cmnd_nmbr++; don't bump for EOF
						} else {
							if(oual_nest_level == 0)
								{
								if(oual_plot_flag != 1)
									 {
									 fprintf(ounit,"\n");
									 fprintf(ounit,"\nDAQ> ");
									 }
								oual_at_EOF=1;
								break;
								}
						}
					 } else {
                                         
                                         strcpy(dosbuf,oual_cmnd);

					 // if doing software interrupt dont get any more params
					 if (oual_sofint != 0)
						{
						strcat(dosbuf,"\n");
						oual_sofint = 0;
						goto noparams2;
						}

					 strcat(dosbuf," ");
					 //getline(oual_cmnd);
					 
					 while ((ptype = gettoken(pname) != T_NL) && (ptype != T_EOF))
                                               {
					       strcat(dosbuf,pname);   
					       strcat(dosbuf," ");
                                               }
					 //strcat(dosbuf,oual_cmnd);
           				 strcat(dosbuf,"\n");

					 noparams2:

					 if(oual_plot_flag != 1) fprintf(ounit,"\nsh> %s\n",dosbuf);
					 //printf("\npassing to system\n");
           system(dosbuf);
					 if(oual_nest_level == 0)
						{
						if(oual_plot_flag != 1) fprintf(ounit,"\nDAQ> ");
						oual_at_EOF = 1;
						// continue;  below fixed dos exit prematurely sometimes 02oct97  dec
                                                goto outerloop;
						}
					}
				}
				flush();
				if ((oual_nest_level > 0) && (oual_verbose > 0)) {
					fprintf(ounit,"\n[%d;%s(%d)]: ",
							oual_nest_level,oual_nest_name,cmnd_nmbr);
				} else {
					if(oual_nest_level == 0)
						{
						if(oual_plot_flag != 1) fprintf(ounit,"\nDAQ> ");
						oual_at_EOF = 1;
						}
				}
			//	break;
			goto outerloop;

			case T_NL:
			plot_fake_nl:

				cmnd_nmbr++;
				if(oual_cmnd_nmbr > 0)
					 {
					 cmnd_nmbr = oual_cmnd_nmbr;
					 oual_cmnd_nmbr = 0;
					 }
				if ((oual_nest_level > 0) && (oual_verbose > 0)) {
					fprintf(ounit,"\n[%d;%s(%d)]: ",
							oual_nest_level,oual_nest_name,cmnd_nmbr);
				} else {
					if(oual_nest_level == 0)
						{
						oual_at_EOF = 1;
						if(oual_plot_flag != 1) fprintf(ounit,"\nDAQ> ");
						}
				}
				// break;
				goto outerloop;

			case T_EOF:
				oual_at_EOF = 1;
				if (oual_nest_level > 0) {
				if(oual_verbose > 0) fprintf(ounit,"\n EOF---");
				return(0);
				} else {
				//break;
				goto outerloop;
				}
/*
* T_INTEGER and T_FLOATING cases are for debugging the tokenizer;
*	they should be evaluated as other unknown words (even as .DAQ execs)
*	when testing is finished...  26Apr91/JEO
*/
			case T_INTEGER:

				fprintf(ounit,"DEBUG(command) input symbol recognized as");
				fprintf(ounit," type INTEGER...\n");
				fprintf(ounit," string '%s' value %ld\n",oual_cmnd,
												atol(oual_cmnd));
				if(oual_nest_level == 0) oual_at_EOF = 1;
				//break;
				goto outerloop;

			case T_FLOAT:

				fprintf(ounit,"DEBUG(command) input symbol recognized as");
				fprintf(ounit," type FLOATING...\n");
				fprintf(ounit," string '%s' value %f\n",oual_cmnd,
												atof(oual_cmnd));
				if(oual_nest_level == 0) oual_at_EOF = 1;
				//break;
				goto outerloop;

			default:

				fprintf(ounit," Special T_SYMBOL\n");
				if(oual_nest_level == 0) oual_at_EOF = 1;
				//break;
				goto outerloop;
		}
	}
return 0;
}
