

/*----------------------------------------------------------------------------
 *  Copyright (c) 1995                     Ohio University
 *                                         Accelerator Laboratory
 *
 *  This software was partially developed under a United States Government
 *  license described in the Notice file included as part of this distribution
 *
 *    Ohio University Accelerator Laboratory, Athens, Ohio  45701
 *
 *    carter@oual3.phy.ohiou.edu   Tel: (614) 593-1984  Fax: (614) 593-1436
 *    odonnell@oual3.phy.ohiou.edu Tel: (614) 593-1977  Fax: (614) 593-1436
 *----------------------------------------------------------------------------
 *
 * Authors:
 *
 *  Don Carter
 *      John O'Donnell
 *
 *  Ohio University Accelerator Laboratory
 *
 * Original version DAQ created 1991
 * Revision History:
 *
 *----------------------------------------------------------------------------*/

#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <oual.h>
#include <conio.h>
#include <unistd.h>

//do not include <goni.h>
// declarations for goniometer control
//int putcomstring(int port, char *string);
//int getcomstring(int port, char *string, int max);
//int sensecom(int port);
//int initcom(int port);
//int initcomports();

extern int oual_ioperm;
int COM1=-1, COM2=-1, portset=-1;
enum POSITION {        TILT, AZIMUTH,  PAN,      X,      Y,       Z};
char current_axis='a';
int current_axis_number=-1;
int last_axis_number=-1;
float limlow[6]  = {    -19,  -90,   -280,    -24,    -24,    -245},
	  limhigh[6] = {     19,   90,    280,     24,     24,     245},
	  realinc[6] = {      0,     0,      0,      0,      0,       0},
	  convert[6] = {  0.0025, 0.0025, 0.0025, 0.00125, 0.00125, 0.00125};
long  realpos[6], steps=0;
int debugger[10]={0,0,0,0,0,0,0,0,0,0};
/* 0 check contents of c:\daq\sys\gonipos.dat
   1 inhibit putcomstring, getcomstring, user enters report K response
   2 report K response unless fault detected
   3 follow intialisation
   4 follow each move
*/
int initdoneok = 0;
FILE *currpos;
int goni(void)
{
oual_retcode=gonicmd(stdin,stdout);
return 1;
}
int gonimove(void)
{
 char answer[83];
 char *anslen;

 char option[16], optnmbr[16], outstring[25], dummystring[83];
 int i, port, moveto=0;
// movementf is an relative floating point movement, mm or degrees
// newposf is an obsolute floating point position, mm or degrees
 float movementf=0.0, newposf=0.0;
// steps is the integer number of steps we will move, declared on main and oual.h
//
//move has been called by user typing move
//
//check for an axis or to or by
//
 
 if(oual_ioperm == 0)
   {
   printf("\nERROR: Must be root for I/O permission!\n");
   flush();
   return -1;
   }
 
 i=gettoken(option);
 //fprintf(oual_ounit,"\noption is %d",i);
 if (i != T_INTEGER && i != T_FLOAT)
// if it is not an integer or real, what is it?
// a number only is an implied by
	{
// test for to by or axis, if not any of these flush
	 if ((strcmp(option,"to") != 0) && (strcmp(option,"by") != 0))
// it had better be an axis
		{
// is it an axis?
		 i=which_axis(option);
		 if (i == -1)
			{
			 fprintf(oual_ounit,"\noption = %s at which_axis = %d is invalid with move try again\n",option,i);
			 flush();
			 return(2);
			}
		 else
			{
// get next token and it must be to or by
			 i=gettoken(option);
			}
		}
// we now must have either to or by in option
// if we do not, then flush
	 if (strcmp(option,"to") != 0 && strcmp(option,"by") != 0)
		{
// either invalid or a number following an axis for a move by
		 if ((i == T_FLOAT) || (i == T_INTEGER))
			{
			 movementf=atof(option);
			 moveto=0;
			}
		 else
			{
			 fprintf(oual_ounit,"\nerror detected in implied move by with axis given\n floating point or integer number bad, i = %d/n",i);
			 flush();
			 return(2);
			}
//	 fprintf(oual_ounit,"\nmovementf =%f",movementf);
		}
	 if (strcmp(option,"to") == 0)
		{
// it is move to
		 i=gettoken(optnmbr);
		 if (i == T_FLOAT || i == T_INTEGER)
			{
			 newposf=atof(optnmbr);
			 moveto=1;
			}
		 else
			{
			 fprintf(oual_ounit,"\nerror detected in move to\n floating point or integer number missing, i = %d/n",i);
			 flush();
			 return(2);
			}

		}
	 if (strcmp(option,"by") == 0)
		{
// it is move by
		 i=gettoken(optnmbr);
		 if (i == T_FLOAT || i == T_INTEGER)
			{
			 movementf=atof(optnmbr);
			 moveto=0;
			}
		 else
			{
			 fprintf(oual_ounit,"\nerror detected in move by\n floating point or integer number missing, i = %d\n",i);
			 flush();
			 return(2);
			}
		}
	 }
// option contains an integer or floating point number for a move by
 else if (i == T_FLOAT || i == T_INTEGER)
		 {
		  movementf=atof(option);
		  moveto=0;
		 }
 else
	  {
	   fprintf(oual_ounit,"\nerror detected in move \n floating point or integer number missing, i = %d\n",i);
	   flush();
	   return(2);
	  }
//check new location valid
 getcurpos();
 if (moveto == 0)
	{
//it is moveby
	 newposf=movementf+realpos[current_axis_number]*convert[current_axis_number];
	}
// now calculate number of steps
 if (moveto == 1)
	 {
	  movementf=newposf-realpos[current_axis_number]*convert[current_axis_number];
	 }
 steps=(movementf/convert[current_axis_number]);
// let's go for it
i=realmove();
//get next command, return to command_c
 return(0);
}
//reportk()
//
// to issue K and report result
int reportk(port)
int port;
enum CODES {IN_MOTION=1,AT_SPEED=2,ACCEL=4,DECEL=8,DRIVE_FAULT=16,
		EMERG_STOP=32,LIMIT=64,COM_FAULT=128};
{
 int i=0,done=0,max=83,motion_status,rcom;
 char answer1[83],answer2[83];
 rcom=port+1;
 while (!done)
	 {
	  delay(500);
	  if(debugger[1] == 0) i=putcomstring(port,"K\r");
	  else  fprintf(oual_ounit,"\nCOM%d putcomstring K",rcom);
	  if(debugger[1] == 0) i=getcomstring(port,answer2,max);
	  else     /* Prompt the user for input */
		  {
		   printf("\nEnter a response to K:");
		   /* read the input */
		   gets(answer2);
		  }
	  if(debugger[2] == 1) fprintf(oual_ounit,"\nIn response to K answer2 = %s, i = %d",answer2,i);
// trouble test
	  motion_status=atoi(answer2);
	  if(motion_status > 15)
		  {
		   if((motion_status&DRIVE_FAULT)==DRIVE_FAULT)
		   {
			printf("\ndrive fault error, k response = %d ",motion_status);
		   }
		   if((motion_status&EMERG_STOP)==EMERG_STOP)
		   {
			printf("\nEMERGENCY STOP, k response = %d ",motion_status);
		   }
		   if((motion_status&LIMIT)==LIMIT)
		   {
			printf("\nLIMIT REACHED, k response = %d ",motion_status);
		   }
		   if((motion_status&COM_FAULT)==COM_FAULT)
		   {
		    printf("\nCOMMUNICATIONS FAULT, k response = %d ",motion_status);
		   }
		  }
	  else if(motion_status > 0 & debugger[2] != 0)
		   {
			printf("\nrunning K response = %d",motion_status);
		   }
	  if (strcmp(answer2,"0")==0) done=1;
	 }
}
//display current status
//
int displaypos()
{
int i;
i=getcurpos();
//printf("\n %d %ld",last_axis_number,steps);
//
// print current values
//
printf("\nThis is where we think we are:");
//printf("\n");
//for (i=TILT;i<=Z;++i) printf("%ld ",realpos[i]);
printf("\n   TILT      AZIMUTH   PAN       X         Y         Z     ");
printf("\n");
for (i=TILT;i<=Z;++i) printf("%9.4f ",realpos[i]*convert[i]);
//printf("\current axis number is = %d, last move in steps = %ld");
if(last_axis_number != -1 && steps != 0)
    {
     switch(last_axis_number)
	 {
	  case TILT:
	      printf("\nLast move was a TILT of %9.4f degrees",steps*convert[last_axis_number]);
	      break;
	  case AZIMUTH:
		  printf("\nLast move was an AZIMUTHAL rotation of %9.4f degrees",steps*convert[last_axis_number]);
	      break;
	  case PAN:
	      printf("\nLast move was a PAN of %9.4f degrees",steps*convert[last_axis_number]);
	      break;
	  case X:
	      printf("\nLast move was a translation of X by %9.4f mm",steps*convert[last_axis_number]);
	      break;
	  case Y:
		  printf("\nLast move was a translation of Y by %9.4f mm",steps*convert[last_axis_number]);
	      break;
	  case Z:
	      printf("\nLast move was a translation of Z by %9.4f mm",steps*convert[last_axis_number]);
	      break;
	 }
    }
return(0);
}
//getcurpos()
//
// open data file and read in past values
//
int getcurpos()
{
int i;
  if ((currpos = fopen("/home/daq/sys/gonipos.dat", "r")) == NULL)
	{
	 fprintf(stderr, "\nCannot open input file.");
	}
for (i=TILT;i<=Z;++i) fscanf(currpos,"%ld ",&realpos[i]);
fscanf(currpos,"\n %d %ld", &last_axis_number,&steps);
fclose(currpos);
end:
return(0);
}
//putcurpos()
//
// open data file and write current values
//
int putcurpos()
{
int i;
// try to open file for output
  if ((currpos = fopen("/home/daq/sys/gonipos.dat", "w")) == NULL)
	{
	 fprintf(stderr, "\nCannot open output file.");
	}
for (i=TILT;i<=Z;++i) fprintf(currpos,"%ld ",realpos[i]);
fprintf(currpos,"\n %d %ld", current_axis_number,steps);
fclose(currpos);
return(0);
}
//whichaxis(teststring)
//determines which axis requested
// return 0 for valid axis
// return 1 for not valid
int which_axis(option)
char option[16];
{
 if (strcmp(option,"u") == 0 || strcmp(option,"U") == 0 || strcmp(option,"tilt") == 0)
	{
	 current_axis='X'; // X is U on COM1
	 current_axis_number=TILT;
	 return(TILT);
	}
 if (strcmp(option,"v") == 0 || strcmp(option,"V") == 0 || strcmp(option,"azimuth") == 0)
	{
	 current_axis='Y'; // Y is V on COM1
	 current_axis_number=AZIMUTH;
	 return(AZIMUTH);
	}
 if (strcmp(option,"w") == 0 || strcmp(option,"W") == 0 || strcmp(option,"pan") == 0)
	{
	 current_axis='Z'; // Z is W on COM1
	 current_axis_number=PAN;
	 return(PAN);
	}
 if (strcmp(option,"x") == 0 || strcmp(option,"X") == 0)
	{
	 current_axis='X';
	 current_axis_number=X;
	 return(X);
	}
 if (strcmp(option,"y") == 0 || strcmp(option,"Y") == 0)
	{
	 current_axis='Y';
	 current_axis_number=Y;
	 return(Y);
	}
 if (strcmp(option,"z") == 0 || strcmp(option,"Z") == 0)
	{
	 current_axis='Z';
	 current_axis_number=Z;
	 return(Z);
	}
// if we get it here it is not a valid axis
 return(-1);
}
//repeat()
//
// repeat the last move
//
int repeat()
{
int i;
 current_axis_number=last_axis_number;
 i=realmove();
//
return(0);
}
//restore()
//
// reverse the last move
//
int restore()
{
int i;
 current_axis_number=last_axis_number;
 steps=-steps;
 i=realmove();
//
return(0);
}
//realmove()
//
// the routine that really sends out the move instructions
//
int realmove()
{
int i, port;
char answer[83],outstring[25];
float newposf=0.0;
 if (current_axis_number <0 || current_axis_number >5)
	{
	 fprintf(oual_ounit,"\nerror detected in move \n current axis invalid = %d %c/n",current_axis_number,current_axis);
	 flush();
	 return(2);
	}
 switch (current_axis_number)
     {
      case TILT:
	  current_axis='X'; // X is U on COM1
	  break;
      case AZIMUTH:
	  current_axis='Y'; // Y is V on COM1
	  break;
      case PAN:
	  current_axis='Z'; // Z is W on COM1
	  break;
      case X:
	  current_axis='X'; // X is X on COM2
	  break;
      case Y:
	  current_axis='Y'; // Y is Y on COM2
	  break;
      case Z:
	  current_axis='Z'; // Z is Z on COM2
	  break;
     }
 if (steps==0)
	{
	 fprintf(oual_ounit,"\nmovement of zero steps requested!\n");
	 flush();
	 return(2);
	}
	 newposf=(realpos[current_axis_number]+steps)*convert[current_axis_number];
	 if (newposf<limlow[current_axis_number])
		{
		 fprintf(oual_ounit,"\nmove to position %f less than low limit %f for axis %c \n",newposf,limlow[current_axis_number],current_axis);
		 flush();
		 return(2);
		}
	 if (newposf>limhigh[current_axis_number])
		{
		 fprintf(oual_ounit,"\nmove to position %f greater than high limit %f for axis %c \n",newposf,limlow[current_axis_number],current_axis);
		 flush();
		 return(2);
		}
// are we intialized?
if (initdoneok != 2)
	{
	 if(debugger[3] != 0) printf("\ncall initcomports");
	 initdoneok=initcomports();
	 if(initdoneok != 2)
		 {
		  printf("\ndo you want me to ask to initialise the ports again?");
	/*	  answer[0]=81;
        	  cgets(answer);    */
                  gets(answer);
		  if (answer[0]=='n' || answer[0]=='N')
			  {
			   initdoneok=2;
			  }
		 }
	}
port=COM2;
if(current_axis_number == 0 || current_axis_number == 1 || current_axis_number == 2)
	 port=COM1;
//printf("\nin realmove com1= %d, com2= %d, port = %d \n",COM1,COM2,port);
// convert steps into characters and put it into outstring
 ltoa(steps,outstring,10);
 if(debugger[4] != 0) fprintf(oual_ounit,"\n port = %d current axis = %c outstring = %s movement = %ld\n",port,current_axis,outstring,steps);
// combine the current axis (XYZ), outstring (steps), $ and carriage return
 sprintf(answer,"%c%s$\r",current_axis,outstring);
 if(debugger[4] != 0) fprintf(oual_ounit,"\n sprintf answer = %s \n",answer);
 flush();
//check port ready
 i=reportk(port);
// make the move
 if(debugger[1] == 0) i=putcomstring(port,answer);
 else  fprintf(oual_ounit,"\nCOM%d putcomstring %s",port+1, answer);
// monitor the move, will not return till done, K=0
 i=reportk(port);
//add move to current position information
 realpos[current_axis_number]=realpos[current_axis_number]+steps;
//save current position information
 putcurpos();
 displaypos();
//get next command, return to command_c
//
return(0);
}
