
/*----------------------------------------------------------------------------
 *  Copyright (c) 1991, 1992, 1993, 1994   Ohio University
 *                                         Accelerator Laboratory
 *
 *  This software was partially developed under a United States Government
 *  license described in the Notice file included as part of this distribution
 * 
 *    Ohio University Accelerator Laboratory, Athens, Ohio  45701
 * 
 *    carter@oual3.phy.ohiou.edu   Tel: (614) 593-1984  Fax: (614) 593-1436
 *    odonnell@oual3.phy.ohiou.edu Tel: (614) 593-1977  Fax: (614) 593-1436 
 *----------------------------------------------------------------------------
 *
 * Authors:
 *
 *	Don Carter
 *      John O'Donnell
 *
 *	Ohio University Accelerator Laboratory
 *
 * Original version DAQ created 1991
 * Revision History:
 *
 * Modified for framework 07-dec-95  d.e.carter
 *  included in this program to control a 6-axis gonoimeter by David C. Ingram
 *  as part of the W.M Keck Thin Film Analaysis Facility
 *  in the Ohio University Accelerator Laboratory
 *  david.ingram@ohiou.edu phone 614 593 1705 fax 614 593 1436
 *
 *----------------------------------------------------------------------------*/

/* Command processing routine for the PC data acquisition system */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <oual.h>
#include <goni.h>

/*command_proc(iunit,ounit)*/
gonicmd(iunit,ounit)
	FILE *iunit, *ounit;
{
	auto char fname[13],save_nest_name[9];
	char dosbuf[133];
	int more,cmnd_nmbr;
	FILE *save_iunit, *save_ounit;

	oual_iunit = iunit;
	oual_ounit = ounit;

	more = 1;
	cmnd_nmbr = 0;

	if (oual_nest_level > 0) fprintf(ounit,"\n[%d;%s(%d)]: ",oual_nest_level,
									oual_nest_name,cmnd_nmbr);

	while ( more ) {

		fflush(stdout);
                switch (gettoken(oual_cmnd)) {

			case T_WORD:
				cmnd_nmbr++;

				if (strcmp(oual_cmnd,"exit") == 0) {
				//	freeram();
					more = 0;
					break;
				}

				else if (strcmp(oual_cmnd,"gonimove") == 0) gonimove();
				else if (strcmp(oual_cmnd,"move") == 0) gonimove();
				else if (strcmp(oual_cmnd,"u") == 0 || strcmp(oual_cmnd,"U") == 0 || strcmp(oual_cmnd,"tilt") == 0)
						{
						 current_axis='U';
						 current_axis_number=TILT;
						}
				else if (strcmp(oual_cmnd,"v") == 0 || strcmp(oual_cmnd,"V") == 0 || strcmp(oual_cmnd,"azimuth") == 0)
						{
						 current_axis='V';
						 current_axis_number=AZIMUTH;
						}
				else if (strcmp(oual_cmnd,"w") == 0 || strcmp(oual_cmnd,"W") == 0 || strcmp(oual_cmnd,"pan") == 0)
						{
						 current_axis='W';
						 current_axis_number=PAN;
						}
				else if (strcmp(oual_cmnd,"x") == 0 || strcmp(oual_cmnd,"X") == 0)
						{
						 current_axis='X';
						 current_axis_number=X;
						}
				else if (strcmp(oual_cmnd,"y") == 0 || strcmp(oual_cmnd,"Y") == 0)
						{
						 current_axis='Y';
						 current_axis_number=Y;
						}
				else if (strcmp(oual_cmnd,"z") == 0 || strcmp(oual_cmnd,"Z") == 0)
						{
						 current_axis='Z';
						 current_axis_number=Z;
						}
				else if (strcmp(oual_cmnd,"repeat") == 0) repeat();
				else if (strcmp(oual_cmnd,"restore") == 0) restore();
				else if (strcmp(oual_cmnd,"where") == 0) displaypos();
				else if (strcmp(oual_cmnd,"delete") == 0) delete();
				else if ((strcmp(oual_cmnd,"define") == 0) ||
					   (strcmp(oual_cmnd,  "def")) == 0) define();
				else if (strcmp(oual_cmnd,"q") == 0) query();
				else if (strcmp(oual_cmnd,"learn") == 0) learn();
				else if (strcmp(oual_cmnd,"rem") == 0) flush();

				else {
					strcpy(fname,oual_cmnd);
					strcat(fname,".daq");
					if ((iunit = fopen(fname,"r")) != NULL) {
						save_iunit = oual_iunit;
						save_ounit = oual_ounit;
						oual_nest_level++;
						strcpy(save_nest_name,oual_nest_name);
						strcpy(oual_nest_name,oual_cmnd);

						command_proc(iunit,ounit);

						oual_nest_level--;
						strcpy(oual_nest_name,save_nest_name);
						oual_iunit = save_iunit;
						oual_ounit = save_ounit;
						fclose(iunit);
						if (oual_nest_level > 0) {
							fprintf(ounit,"> [%d;%s(%d)]",oual_nest_level,
												oual_nest_name,cmnd_nmbr
												);
						} else {
							fprintf(ounit,"\n");
							fprintf(ounit,"\nGoni> ");
							break;
						}
					 } else {
					 strcpy(dosbuf,oual_cmnd);

					 strcat(dosbuf," ");
					 getline(oual_cmnd);
					 strcat(dosbuf,oual_cmnd);

					 fprintf(ounit,"\nDOS> %s\n",dosbuf);
					 system(dosbuf);
					 if(oual_nest_level == 0)
						{
						fprintf(ounit,"\nGoni> ");
						continue;
						}
					}
				}
				flush();
				if (oual_nest_level > 0) {
					fprintf(ounit,"\n[%d;%s(%d)]: ",
							oual_nest_level,oual_nest_name,cmnd_nmbr);
				} else {
					fprintf(ounit,"\nGoni> ");
				}
				break;

			case T_NL:

				cmnd_nmbr++;
				if (oual_nest_level > 0) {
					fprintf(ounit,"\n[%d;%s(%d)]: ",
							oual_nest_level,oual_nest_name,cmnd_nmbr);
				} else {
					fprintf(ounit,"\nGoni> ");
				}
				break;

			case T_EOF:

				if (oual_nest_level > 0) {
				fprintf(ounit," EOF---");
				return(0);
				} else {
				break;
				}
/*
* T_INTEGER and T_FLOATING cases are for debugging the tokenizer;
*	they should be evaluated as other unknown words (even as .DAQ execs)
*	when testing is finished...  26Apr91/JEO
*/
			case T_INTEGER:

				fprintf(ounit,"DEBUG(command) input symbol recognized as");
				fprintf(ounit," type INTEGER...\n");
				fprintf(ounit," string '%s' value %ld\n",oual_cmnd,
												atol(oual_cmnd));
				break;

			case T_FLOAT:

				fprintf(ounit,"DEBUG(command) input symbol recognized as");
				fprintf(ounit," type FLOATING...\n");
				fprintf(ounit," string '%s' value %f\n",oual_cmnd,
												atof(oual_cmnd));
				break;

			default:

				fprintf(ounit," Special T_SYMBOL\n");
				break;
		}
	}
return 0;
}
