#include <dos.h>
#include <bios.h>
#include <stdio.h>
#include <oual.h>
#include <signal.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

char oual_system_name[80] = "*** No Interrupt Installed ***\n";

extern int oual_event_flag;

int ilevel = 5, icu = 0x21;
int ouindex;
int oual_bcichan = 10;
char intflag = 0; 


//char oual_system_name[] = "adc8 (vector 0 - 7)\n";

void adc8_int(void)
{

databufferptr = (struct databuffer *) shmptr;

databufferptr->dav = 1;
if(databufferptr->nevents <= 0) goto ret;  //return;

//databufferptr->dav = 1; /* set data available (hold off irq) */

if(oual_anal == 0) goto ret;

ouindex=0;

if(databufferptr->nevents > 4095) histogram(9,0xfff);
  else histogram(9,databufferptr->nevents);

while(databufferptr->nevents-- > 0)
  
  {
  if(((oual_rawdata=databufferptr->data[ouindex++]) & 0x8000) == 0) /* is data present */
     {
     if(oual_anal == 0) goto ret;
     oual_adcdata=oual_rawdata & 0xfff;
     oual_adcnumber=(oual_rawdata & 0x7000) >> 12;
     histogram(oual_adcnumber,oual_adcdata);
     if(histogram((oual_adcnumber+10),oual_adcdata) == 0)
         {
         if(oual_counter > 0)
           {
           if (--oual_counter == 0)
             {
             intstate(0);
             oual_terminate = 1;
             goto ret;
             }
           }
         }
     }
  }
ret:
databufferptr->nevents = 0;
databufferptr->dav = 0; /* set no data available */
return;
/*************************************************
*/
}
//char oual_system_name[] = "nmr v1.0: adc0=x adc1=y";

void nmr_int(void)
{
unsigned x,y;
unsigned x_y;

databufferptr = (struct databuffer *) shmptr;

databufferptr->dav = 1;
if(databufferptr->nevents <= 0) goto ret;  //return;

//databufferptr->dav = 1; /* set data available (hold off irq) */

if(oual_anal == 0)goto ret;

ouindex=0;

while(databufferptr->nevents-- > 0)
  {
  if(((oual_rawdata=databufferptr->data[ouindex++]) & 0x8000) == 0) /* is data present */
     {
     if(oual_anal == 0) goto ret;
     oual_adcdata=oual_rawdata & 0xfff;
     oual_adcnumber=(oual_rawdata & 0x7000) >> 12;
     if(oual_adcnumber == 0) 
       {
       x = oual_adcdata;
       histogram(0,x);
       }
     if(oual_adcnumber == 1) 
       {
       y = oual_adcdata;
       histogram(1,y);
       xy(2,x,y);
       }
     }
  }
ret:
databufferptr->nevents = 0;
databufferptr->dav = 0; /* set no data available */
return;
}

/********************************************************************
*/

void goni_int(void)
{

databufferptr = (struct databuffer *) shmptr;

databufferptr->dav = 1; /* set data available (hold off irq) */
if(databufferptr->nevents <= 0) goto ret;

if(oual_anal == 0) goto ret;

ouindex=0;

while(databufferptr->nevents-- > 0)
  {
  if(((oual_rawdata=databufferptr->data[ouindex++]) & 0x8000) == 0) /* is data present */
     {
     if(oual_anal == 0) goto ret;
     oual_adcdata=oual_rawdata & 0xfff;
     oual_adcnumber=(oual_rawdata & 0x7000) >> 12;
     if(oual_t0 == 1234)
       {
       switch(oual_adcnumber)
         {
         case 5:
           oual_adcnumber = 1; //adc5 = rbs
           break;
         case 3:
           oual_adcnumber = 2; //adc3 = ltdt
           break;  
         case 4:
           oual_adcnumber = 3; //adc4 = bci
           break;
         case 6:
           oual_adcnumber = 0; //adc6 = prd
           break;
         default:
           oual_adcnumber = 7;
           break;
         }
       }   
     if(oual_adcnumber == 3)
       {
       histogram(3,oual_bcichan);
       if(histogram(13,oual_bcichan++) == 0)
         {
         if(oual_counter > 0)
           {
           if (--oual_counter == 0)
             {
             intstate(0);
             oual_terminate = 1;
             }
           }
         }
       if(oual_bcichan == 110) oual_bcichan = 10;
       }
     else if(oual_adcnumber < 3)
       {
       histogram(oual_adcnumber,oual_adcdata);
       if(oual_adcnumber < 2) histogram(oual_adcnumber+4,oual_adcdata);
       if(histogram(oual_adcnumber+10,oual_adcdata) == 0)
         {
         if(oual_counter > 0)
           {
           if (--oual_counter == 0)
             {
             intstate(0);
             oual_terminate = 1;
             goto ret;
             }
           }
         }
       }
     }
  }
ret:
databufferptr->nevents = 0;
databufferptr->dav = 0; /* set no data available */
return;
}

/********************************************************************
*/
/* * * * * * * * * * * */
/*
** Function to save event data in the array pointed to by vector.
**
**    returns 0 if event saved ok.
**
**    the first channel of the array contains a count of how many events
**    are in this event mode buffer.
**
*/

int oual_event = 0;

int event( unsigned vector, unsigned data)
{
int v;
unsigned *ptr;
unsigned addr;

if ((v = oual_vector[vector]) < 0 ) return 1;
ptr = oual_define[v].address;
if ((addr = *ptr) >= oual_define[v].length)
	{
	oual_event_flag = 1;
	return 2;                      /* buffer full */
	}
oual_event = addr;
*ptr = *ptr + 1;
ptr += addr+1;
*ptr = data;
return 0;
}

/* * * * * * * * * * */
/*
** histogram the array pointed to by vector after the criteria
** defined by vector are applied i.e. conversion gain, lld, uld
** offset, array length etc.
**
** returns 0 if histogram valid.
*/

int histogram( unsigned vector, unsigned data)
{
int v, shift, i, p;
unsigned *ptr;
unsigned d;
if ((v = oual_vector[vector]) < 0 ) return 1;       /* vector not defined */
if ((p = oual_define[v].prescale_init) > 1)
	{
	oual_define[v].prescale--;
	if(oual_define[v].prescale > 0) return 0;
	else oual_define[v].prescale = p;
	}
shift = oual_define[v].shift;
d = data;
if (shift != 0) for (i = 0; i < shift; i++) d = d >> 1;
if(d < oual_define[v].lld) return 2;             /* less than lld        */
if(d > oual_define[v].uld) return 3;             /* greater than uld     */
d = d - oual_define[v].digital_offset;
if(d >= oual_define[v].length) return 4;          /* data beyond array    */
ptr = oual_define[v].address;
ptr += d;
if((*ptr = *ptr + 1) == 0) // check for overflow
	{
	if(p > 0) // auto prescale allowed?
		{
		oual_define[v].prescale_init = p << 1;  // prescale = prescale * 2
		oual_define[v].prescale = p << 1;
		*ptr = 65535;
		ptr = oual_define[v].address;
		for(i = 0; i < oual_define[v].length ; i++)  // prescale current data
			{
			*ptr = *ptr >> 1;
			ptr += 1;
			}
		}
	}
return 0;
}

/* poke y into x */

int xy( unsigned vector, unsigned datax, unsigned datay)
{
int v, shift, i, p;
unsigned *ptr;
unsigned d;
if ((v = oual_vector[vector]) < 0 ) return 1;       /* vector not defined */
if ((p = oual_define[v].prescale_init) > 1)
	{
	oual_define[v].prescale--;
	if(oual_define[v].prescale > 0) return 0;
	else oual_define[v].prescale = p;
	}
shift = oual_define[v].shift;
d = datax;
if (shift != 0) for (i = 0; i < shift; i++) d = d >> 1;
if(d < oual_define[v].lld) return 2;             /* less than lld        */
if(d > oual_define[v].uld) return 3;             /* greater than uld     */
d = d - oual_define[v].digital_offset;
if(d >= oual_define[v].length) return 4;          /* data beyond array    */
ptr = oual_define[v].address;
ptr += d;
*ptr = datay;
return 0;
}

/* * * * * * * * * * * */
/*
** function to check if data normalized to vector satisfies the
** gate specified.
**
** returns 1 if gate satisfied.
*/
int checkgate( unsigned gate, unsigned vector, unsigned data)
{
unsigned addr;
int value;

if((value = normalize(vector,data)) == -1) return 0;
if(((addr = gate << 1) + 1) >= oual_ngates) return 0;
if((value < oual_gate[addr]) || (value > oual_gate[addr+1])) return 0;
				/* less than lower level or greater than upper level  */
return 1;       /* normalized value is within gates */
}

/* * * * * * * * * * */
/*
** return the data value normalized by vector.
**
** if not a good value, returns -1.
*/

int normalize( unsigned vector, unsigned data)

{
int v, shift, i;
int d;

if ((v = oual_vector[vector]) < 0 ) return -1;       /* vector not defined */
shift = oual_define[v].shift;
d = data;
if (shift != 0) for (i = 0; i < shift; i++) d = d >> 1;
if(d < oual_define[v].lld) return -1;             /* less than lld        */
if(d > oual_define[v].uld) return -1;             /* greater than uld     */
d = d - oual_define[v].digital_offset;
if(d >= oual_define[v].length) return -1;          /* data beyond array    */
return d;
}

/* * * * * * * * * * * */
/*
** Function to get event data from the array pointed to by vector.
**
**    returns -1 if beyond event end.
**
**    the first channel of the array contains a count of how many events
**    are in this event mode buffer.
**
*/
int getevent( unsigned vector, unsigned address)

{
int v;
unsigned *ptr;
if ((v = oual_vector[vector]) < 0 ) return -1; /* vector not defined */
ptr = oual_define[v].address;
if ( *ptr < address ) return -1; /* end of event data */
ptr += address;
return (*ptr);
}

/* * * * * * * * * * * */
/*
** function to check if data normalized to vector satisfies the
** rgate specified.
**
** returns 1 if gate satisfied.
*/
int checkrgate( unsigned gate, unsigned vector, unsigned data)
{

unsigned addr;
int value;

if((value = normalize(vector,data)) == -1) return 0;
if (gate >= oual_nrgates) return 0;
addr = gate * 6;
if((value < oual_rgate[addr]) || (value > oual_rgate[addr+1])) return 0;
return 1;       /* normalized value is within gates */
}
/*
** set oual_rawdata, oual_adcdata, oual_adcnumber if there was data
** present from the adc port.  Function returns 1 if data present,
** else 0.
**
** d.e.carter
*/

int getadc()
{
char icu=0x20, eoi=0x20;
if (oual_anal == 1) /* Is aquire data turned on? */
	{
	oual_rawdata=inport(0x300);               /* Read Data Port */
	if((oual_rawdata & 0x8000) == 0)           /* If data present proceed */
		{
		oual_adcnumber = ((oual_rawdata & 0x7000) >> 12);
		oual_adcdata = oual_rawdata & 0xfff;
		oual_router  = inport(0x304) & 0xfff;
		inport(0x302);
		// outportb(icu,eoi);
		return(1);
		}
	}
return(0);
}
//int ilevel = 5, icu = 0x21;
//char intflag = 0;

extern double totdiff,begtim0,begtime,endtime;

extern void /*interrupt*/ intupt1(unsigned bp, unsigned di, unsigned si,
				   unsigned ds, unsigned es, unsigned dx,
				   unsigned cx, unsigned bx, unsigned ax);

//void install(void /* interrupt */ (*faddr) (), int inum)
//{
	// win95 * setvect(inum, faddr);
//}
intstate(state)
int state;
{

int vector;
char pname[20];

if (state == 2)
	{
	char name[16];
	if(gettoken(name) != T_WORD)
		{
		fprintf(oual_ounit,"\nERROR(loadint): Need name of interrupt to load.\n");
		goto shownames;
		}
	if (strcmp(name,"8adc") == 0)
			{
			//install(adc8_int,vector); 			/* install interrupt      */
			signal(SIGUSR1,adc8_int);
                        strcpy(oual_system_name,"8 ADC (vector 0 - 7)\n");
			}
        else if (strcmp(name,"goni") == 0)
			{
			//install(goni_int,vector); 			/* install interrupt      */
			signal(SIGUSR1,goni_int);
                        strcpy(oual_system_name,"Goni 16 February 2000 8adc version\n");
			}
        else if (strcmp(name,"nmr") == 0)
			{
			//install(nmr_int,vector); 			/* install interrupt      */
			signal(SIGUSR1,nmr_int);
                        strcpy(oual_system_name,"NMR V1.0\n");
			}
	else
			{
			printf("\n ERROR(loadint) Interrupt %s not known.",name);
	shownames:
			printf("\n ( adc8, goni) \n");
			flush();
			return 1;
			}
	flush();
	intflag = 1;
	return 0;
	}

if (state == 1)
        {
	if (intflag == 0)
		{
		flush();
                vector = ilevel + 8;  				/* set interrupt vector   */
getname:
		printf("\nEnter Interrupt Name: 8adc, goni, nmr\n");
		//pname[0]=18;
                //gets(pname);
		//strcpy(pname,"");
                fgets(pname,18,oual_iunit);
                if (strcmp(pname,"8adc\n") == 0)
			{
			//install(adc8_int,vector); 			/* install interrupt      */
			signal(SIGUSR1,adc8_int);
                        strcpy(oual_system_name,"8 ADC (vector 0 - 7)\n");
			}
		else if (strcmp(pname,"goni\n") == 0)
			{
			//install(goni_int,vector); 			/* install interrupt      */
			signal(SIGUSR1,goni_int);
                        strcpy(oual_system_name,"Goni 16 February 2000 8adc version\n");
			}
                else if (strcmp(pname,"nmr\n") == 0)
			{
			//install(nmr_int,vector); 			/* install interrupt      */
			signal(SIGUSR1,nmr_int);
                        strcpy(oual_system_name,"NMR V1.0\n");
			}
                else
			{
			printf("\n ERROR(intstate) Interrupt %s not known.\n",pname);
			goto getname;
			}
		intflag = 1;
		}
	oual_anal = 1;
	begtime = clock();
	begtim0 = begtime;
        databufferptr = (struct databuffer *) shmptr;
        databufferptr->dav=0;
        databufferptr->nevents=0;
        //daq_int();  /* call the interrupt */
        kill(getpid(),SIGUSR1);
        //databufferptr->dav=0;
        }
if (state == 0)
	{
        oual_anal = 0;
	endtime = clock();
	totdiff = totdiff + difftime(endtime,begtime)/ CLK_TCK;
	}
flush();
return;
}

