/*----------------------------------------------------------------------------
 *  Copyright (c) 1991, 1992, 1993, 1994, 1995   Ohio University
 *                                               Accelerator Laboratory
 *
 *  This software was partially developed under a United States Government
 *  license described in the Notice file included as part of this distribution
 *
 *    Ohio University Accelerator Laboratory, Athens, Ohio  45701
 *
 *    carter@oual3.phy.ohiou.edu   Tel: (614) 593-1984  Fax: (614) 593-1436
 *----------------------------------------------------------------------------
 *
 * Author:
 *
 *      Don Carter
 *
 *      Ohio University Accelerator Laboratory
 *
 * Original version DAQ created 1991
 * Revision History:
 *
 *----------------------------------------------------------------------------*/

#include <dos.h>
#include <bios.h>
#include <stdio.h>
#include <oual.h>
#include <stdlib.h>
#include <string.h>
#include <alloc.h>
#include <time.h>
#include <math.h>

//extern unsigned oual_rgate[], oual_nrgates, oual_t0;

int jackrep()

/* jackrep sourcevec histvec evstart evstop [disk#] */

{

// d.e.carter  22 July 1998

char name[16];
int data, end, channel, vec, g;
unsigned i, j, det;
unsigned evstart, evstop, evnum, disk;
unsigned long e_psd, e_tof;
double q1q2;

//unsigned e,de,tof,etof,route,ede;
//unsigned raw_e,raw_de,raw_tof,raw_etof,raw_route;
//unsigned long e_tof,de_e,de_ede,mass;

FILE *f;
int index;
unsigned long savtim,savdat;
char fname[16],fpath[80];
char option[16],optnmbr[16];
int tag,start,stop;
int tagincr;
int opt_type;
unsigned idata;
unsigned q0, q1, tof1, tof2, tof3, tof23;

unsigned *ptr;
unsigned irep, jrep, v = 0, v_dest = 0;

//++++++

switch (gettoken(name)) {

case T_INTEGER:

	v = (unsigned)atoi(name);
	break;

case T_WORD:

	for (i = 0; i <= oual_nvectors; i++) {

		if((vec = oual_vector[i]) == -1) continue;
		if(oual_define[vec].name[0] == 0) continue;
		if (strcmp(oual_define[vec].name,name) == 0)
						v = i;
		}
	break;

case T_NL:

	fprintf(oual_ounit,"\n(jackrep): Need source vector.");
	flush();
	return(0);
	}


switch (gettoken(name)) {

case T_INTEGER:

	v_dest = (unsigned)atoi(name);
	break;

case T_WORD:

	for (i = 0; i <= oual_nvectors; i++) {

		if((vec = oual_vector[i]) == -1) continue;
		if(oual_define[vec].name[0] == 0) continue;
		if (strcmp(oual_define[vec].name,name) == 0)
						v_dest = i;
		}
	break;

case T_NL:

	fprintf(oual_ounit,"\n(jackrep): Need destination vector.");
	flush();
	return(0);
	}

switch (gettoken(name)) {

case T_INTEGER:

	evstart = (unsigned)atoi(name);
	break;

default:

	fprintf(oual_ounit,"\n(jackrep): Need evstart.");
	flush();
	return(0);
	}


switch (gettoken(name)) {

case T_INTEGER:

	evstop = (unsigned)atoi(name);
	break;

default:

	fprintf(oual_ounit,"\n(jackrep): Need evstop.");
	flush();
	return(0);
	}

disk = oual_disk;

switch (gettoken(name)) {

case T_INTEGER:

	disk = (unsigned)atoi(name);
	break;
	}

/* get the events into the event buffers */

for ( evnum=evstart; evnum<=evstop; evnum++) {

index = def_index("ev_q0");
if(index == -1)
	{
	fprintf(oual_ounit,"\n(jackrep): ev_q0 not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data/EVT%04d/EV_Q0.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_q0 from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\n(jackrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
	   {
	   fprintf(oual_ounit,"\n(jackrep): event buffer too small.");
	   flush();
	   return(10);
	   }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);


index = def_index("ev_q1");
if(index == -1)
	{
	fprintf(oual_ounit,"\n(jackrep): ev_q1 not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data/EVT%04d/EV_Q1.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_q1 from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\n(jackrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
	   {
	   fprintf(oual_ounit,"\n(jackrep): event buffer too small.");
	   flush();
	   return(10);
	   }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);
/*
index = def_index("ev_q2");
if(index == -1)
	{
	fprintf(oual_ounit,"\n(jackrep): ev_q2 not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data\\evt%04d\\ev_q2.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_q2 from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\n(jackrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
	   {
	   fprintf(oual_ounit,"\n(jackrep): event buffer too small.");
	   flush();
	   return(10);
	   }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);

index = def_index("ev_q3");
if(index == -1)
	{
	fprintf(oual_ounit,"\n(jackrep): ev_q3 not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data\\evt%04d\\ev_q3.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_q3 from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\n(jackrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
	   {
	   fprintf(oual_ounit,"\n(jackrep): event buffer too small.");
	   flush();
	   return(10);
	   }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);
*/
index = def_index("ev_tof1");
if(index == -1)
	{
	fprintf(oual_ounit,"\n(jackrep): ev_tof1 not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data/EVT%04d/EV_TOF1.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_tof1 from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\n(jackrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
	   {
	   fprintf(oual_ounit,"\n(jackrep): event buffer too small.");
	   flush();
	   return(10);
	   }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);

index = def_index("ev_tof2");
if(index == -1)
	{
	fprintf(oual_ounit,"\n(jackrep): ev_tof2 not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data/EVT%04d/EV_TOF2.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_tof2 from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\n(jackrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
	   {
	   fprintf(oual_ounit,"\n(jackrep): event buffer too small.");
	   flush();
	   return(10);
	   }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);

index = def_index("ev_tof3");
if(index == -1)
	{
	fprintf(oual_ounit,"\n(jackrep): ev_tof3 not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data/EVT%04d/EV_TOF3.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_tof3 from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\n(jackrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
	   {
	   fprintf(oual_ounit,"\n(jackrep): event buffer too small.");
	   flush();
	   return(10);
	   }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);

/* event buffers now contain event data; now process */

end = getevent(v,0);

if (end == -1) return(2);

fprintf(oual_ounit,"\nProcessing %u events...",end);

for ( i=1; i < end; i++)
	{
	//det = (getevent(v, i) >> 12) & 7;
	//fprintf(oual_ounit,"\nDoing %u Det = %u",oual_t0,det);
		//if(det == oual_t0)
		//{
  		q0 = getevent(20,i) & 0xfff;
  		q1 = getevent(21,i) & 0xfff;
		tof1 = getevent(30,i) & 0xfff;
		tof2 = getevent(31,i) & 0xfff;
		tof3 = getevent(32,i) & 0xfff;
		histogram (50,tof2);
                histogram (51,tof3);
		tof23 = (2048 + (tof2 - tof3));
	//	if(((checkgate(1,10,tof1)) == 1) &&
    
        //		   ((checkgate(2,17,tof23)) == 1))
                if(1)
		{
  		histogram(1,q0);
  		histogram(2,q1);
                histogram(10,tof1);
                histogram(11,tof2);
                histogram(12,tof3);

/*		e_psd=(((((unsigned long)q0 & (unsigned long)0xfc0)
							<< 6) | (unsigned long)q1) >> 6);
		histogram(40, (unsigned) e_psd);
		e_tof=(((((unsigned long)tof1 & (unsigned long)0xfc0)
							<< 6) | (unsigned long)q0) >> 6);
		histogram(41, (unsigned) e_tof);
		e_tof=(((((unsigned long)tof1 & (unsigned long)0xfc0)
							<< 6) | (unsigned long)q1) >> 6);
		histogram(42, (unsigned) e_tof);
*/
			histogram(14,(tof1 + tof2) >> 1);
			histogram(15,(tof2 + tof3) >> 1);
			histogram(16,(2048 + (tof1 - tof2)));
			histogram(17,(2048 + (tof2 - tof3)));
			}
		  
		//q1q2 = sqrt((double)q0*(double)q1);
                q1q2 = 256.0+(100.0*(log((double)q0/(double)q1)));
		histogram(6,(unsigned)q1q2);
                /*
		data = getevent( v, i) & 0xfff;
		//histogram( v_dest, data);
		for ( j = 0; j < oual_nrgates; j++ )
			{
			if (oual_rgate[(6*j)+2] == v)
				{
				if (checkrgate(j, v_dest, data) == 1)
					{
					if(oual_define[oual_vector[oual_rgate[(6*j)+5]]].type == 1)
						channel = (getevent(oual_rgate[(6*j)+4],i) & 0xfc0)  |
						  ((getevent(oual_rgate[(6*j)+3],i) & 0xfc0) >> 6);

					else
						channel = getevent( oual_rgate[(6*j)+3], i) & 0xfff;
					histogram( oual_rgate[(6*j)+5], channel);
					}
				}
			}
		*/
		//}
	}

} /* terminates fn.ext loop */
return 0;
} /* terminates jackrep main */

