/*----------------------------------------------------------------------------
 *  Copyright (c) 1991, 1992, 1993, 1994, 1995   Ohio University
 *                                               Accelerator Laboratory
 *
 *  This software was partially developed under a United States Government
 *  license described in the Notice file included as part of this distribution
 * 
 *    Ohio University Accelerator Laboratory, Athens, Ohio  45701
 * 
 *    carter@oual3.phy.ohiou.edu   Tel: (614) 593-1984  Fax: (614) 593-1436 
 *----------------------------------------------------------------------------
 *
 * Author:
 *
 *      Don Carter
 *
 *      Ohio University Accelerator Laboratory
 *
 * Original version DAQ created 1991
 * Revision History:
 *
 *----------------------------------------------------------------------------*/

#include <dos.h>
#include <bios.h>
#include <stdio.h>
#include <oual.h>
#include <stdlib.h>
#include <string.h>
#include <alloc.h>
#include <time.h>

//extern unsigned oual_rgate[], oual_nrgates, oual_t0;

int nisrep()

/* nisrep evstart evstop disk */

{

char name[16];
int data, end, channel, vec;
unsigned i, j, det;
unsigned evstart, evstop, evnum, disk;

unsigned e,de,tof,etof,route;
unsigned raw_e,raw_de,raw_tof,raw_etof,raw_route;
unsigned long e_tof,mass;

FILE *f;
int index;
unsigned long savtim,savdat;
char fname[16],fpath[80];
char option[16],optnmbr[16];
int tag,start,stop;
int tagincr;
int opt_type;
unsigned idata;

unsigned *ptr;


switch (gettoken(name)) {

case T_INTEGER:

	evstart = (unsigned)atoi(name);
	break;

default:

    fprintf(oual_ounit,"\nERROR(nisrep): Need evstart.");
    flush();
    return(0);
    }


switch (gettoken(name)) {

case T_INTEGER:

	evstop = (unsigned)atoi(name);
	break;

default:

    fprintf(oual_ounit,"\nERROR(nisrep): Need evstop.");
    flush();
    return(0);
    }

disk = oual_disk;

switch (gettoken(name)) {

case T_INTEGER:

	disk = (unsigned)atoi(name);
	break;
	}

/* get the events into the event buffers */

for ( evnum=evstart; evnum<=evstop; evnum++) {

index = def_index("ev_e");
if(index == -1)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): ev_e not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data\\evt%04d\\ev_e.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_e from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
       {
       fprintf(oual_ounit,"\nERROR(nisrep): event buffer too small.");
       flush();
       return(10);
       }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);


index = def_index("ev_de");
if(index == -1)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): ev_de not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data\\evt%04d\\ev_de.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_de from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
       {
       fprintf(oual_ounit,"\nERROR(nisrep): event buffer too small.");
       flush();
       return(10);
       }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);


index = def_index("ev_tof");
if(index == -1)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): ev_tof not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data\\evt%04d\\ev_tof.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_tof from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
       {
       fprintf(oual_ounit,"\nERROR(nisrep): event buffer too small.");
       flush();
       return(10);
       }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);


index = def_index("ev_etof");
if(index == -1)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): ev_etof not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data\\evt%04d\\ev_etof.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_etof from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
       {
       fprintf(oual_ounit,"\nERROR(nisrep): event buffer too small.");
       flush();
       return(10);
       }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);

index = def_index("ev_route");
if(index == -1)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): ev_route not defined");
	flush();
	return(10);
	}

sprintf(fpath,"data\\evt%04d\\ev_route.%03d",disk,evnum);

fprintf(oual_ounit,"\nGetting ev_route from file %s.",fpath);

if ((f = fopen (fpath,"r")) == NULL)
	{
	fprintf(oual_ounit,"\nERROR(nisrep): Cannot open %s",fpath);
	flush();
	return(10);
	}

fscanf(f," %07u %07u %07u %07u %07lu %07lu",&disk,&tag,&start,&stop,&savdat,&savtim);
ptr = oual_define[index].address;
if (((stop - start) + 1) > oual_define[index].length)
       {
       fprintf(oual_ounit,"\nERROR(nisrep): event buffer too small.");
       flush();
       return(10);
       }
for (i=start; i<=stop; i++) {
	fscanf(f,"%08u",&idata);
	*ptr++ = idata;
	}
fclose(f);

/* event buffers now contain event data; now process */


/* ************************************** 
 * e     event buffer is vector 140
 * de    event buffer is vector 141
 * tof   event buffer is vector 142
 * etov  event buffer is vector 143
 * route event buffer is vector 144
 * length of event is in event(*,0)
 */


end = getevent(140,0);

if (end == -1) return(2);

fprintf(oual_ounit,"\nProcessing %u events...",end);

for ( i=1; i < end; i++)
	{
	e           = getevent(140,i) & 0xfff;
	de          = getevent(141,i) & 0xfff;
	tof         = getevent(142,i) & 0xfff;
	etof        = getevent(143,i) & 0xfff;
	oual_router = getevent(144,i) & 0xfff;
	
	switch (oual_router)
		{
		case 0:
			route = 0;
			break;
		case 1:
			route = 10;
			break;
		case 2:
			route = 20;
			break;
		case 4:
			route = 30;
			break;
		case 8:
			route = 40;
			break;
		case 16:
			route = 50;
			break;
		case 32:
			route = 60;
			break;
		case 64:
			route = 70;
			break;
		case 128:
			route = 80;
			break;
		case 256:
			route = 90;
			break;
		case 512:
			route = 100;
			break;
		case 1024:
			route = 110;
			break;
		default:
			histogram(130,oual_router);
			route = 120;
			break;
		}

	histogram(route,e);
	histogram(route+1,de);
	histogram(route+2,tof);
	histogram(route+3,etof);
	e_tof=(((((unsigned long)tof & (unsigned long)0xfc0)
		<< 6) | (unsigned long)e) >> 6);
	histogram(route+4, (unsigned) e_tof);
	e_tof=(((((unsigned long)de & (unsigned long)0xfc0)
		<< 6) | (unsigned long)e) >> 6);
	histogram(route+5, (unsigned) e_tof);
	e = ( e + de ) >> 1;
	mass = ((unsigned long)e * ((((unsigned long)oual_t0 - (unsigned long)tof)
		* ((unsigned long)oual_t0 - (unsigned long)tof)) >> 10)) >> 10;
	mass = mass & 0xfff;
	histogram(route+6, (unsigned) mass);

	}
} /* terminates fn.ext loop */
return 0;
} /* terminates nisrep main */

