
/*----------------------------------------------------------------------------
 *  Copyright (c) 1991, 1992, 1993, 1994   Ohio University
 *                                         Accelerator Laboratory
 *
 *  This software was partially developed under a United States Government
 *  license described in the Notice file included as part of this distribution
 * 
 *    Ohio University Accelerator Laboratory, Athens, Ohio  45701
 * 
 *    carter@oual3.phy.ohiou.edu   Tel: (614) 593-1984  Fax: (614) 593-1436 
 *    odonnell@oual3.phy.ohiou.edu Tel: (614) 593-1977  Fax: (614) 593-1436 
 *----------------------------------------------------------------------------
 *
 * Authors:
 *
 *	Don Carter
 *      John O'Donnell
 *
 *	Ohio University Accelerator Laboratory
 *
 * Original version DAQ created 1991
 * Revision History:
 *
 *----------------------------------------------------------------------------*/

#include <dos.h>
#include <bios.h>
#include <stdio.h>
#include <oual.h>

//extern unsigned oual_rgate[], oual_nrgates, oual_t0;

int replay()

{

char name[16];
int data, end, channel, vec;
unsigned i, j, v = 0, v_dest = 0, det;

switch (gettoken(name)) {

case T_INTEGER:

	v = (unsigned)atoi(name);
	break;

case T_WORD:

	for (i = 0; i <= oual_nvectors; i++) {

		if((vec = oual_vector[i]) == -1) continue;
		if(oual_define[vec].name[0] == 0) continue;
		if (strcmp(oual_define[vec].name,name) == 0)
						v = i;
		}
	break;

case T_NL:

	fprintf(oual_ounit,"\nERROR(replay): Need source vector.");
	flush();
	return(0);
	}


switch (gettoken(name)) {

case T_INTEGER:

	v_dest = (unsigned)atoi(name);
	break;

case T_WORD:

	for (i = 0; i <= oual_nvectors; i++) {

		if((vec = oual_vector[i]) == -1) continue;
		if(oual_define[vec].name[0] == 0) continue;
		if (strcmp(oual_define[vec].name,name) == 0)
						v_dest = i;
		}
	break;

case T_NL:

	fprintf(oual_ounit,"\nERROR(replay): Need destination vector.");
	flush();
	return(0);
	}

end = getevent(v,0);

if (end == -1) return(2);

for ( i=1; i < end; i++)
	{
	det = (getevent(v, i) >> 12) & 7;
	fprintf(oual_ounit,"\nDoing %u Det = %u",oual_t0,det);
		if(det == oual_t0)
		{
		data = getevent( v, i) & 0xfff;
		histogram( v_dest, data);
		for ( j = 0; j < oual_nrgates; j++ )
			{
			if (oual_rgate[(6*j)+2] == v)
				{
				if (checkrgate(j, v_dest, data) == 1)
					{
					if(oual_define[oual_vector[oual_rgate[(6*j)+5]]].type == 1)
						channel = (getevent(oual_rgate[(6*j)+4],i) & 0xfc0)  |
						  ((getevent(oual_rgate[(6*j)+3],i) & 0xfc0) >> 6);

					else
						channel = getevent( oual_rgate[(6*j)+3], i) & 0xfff;
					histogram( oual_rgate[(6*j)+5], channel);
					}
				}
			}
		}
	}
return 0;
}

/* * * * * * * * * * * *
*
** Function to get event data from the array pointed to by vector.
**
**    returns -1 if beyond event end.
**
**    the first channel of the array contains a count of how many events
**    are in this event mode buffer.
**
*

int getevent( unsigned vector, unsigned address)
{
int v;
unsigned far *ptr;

if ((v = oual_vector[vector]) < 0 ) return -1;
												/* vector not defined *
ptr = oual_define[v].address;

if ( *ptr < address ) return -1; /* end of event data *
ptr += address;
return (*ptr);
}

/* * * * * * * * * * * */
/*
** function to check if data normalized to vector satisfies the
** rgate specified.
**
** returns 1 if gate satisfied.
*
int checkrgate( unsigned gate, unsigned vector, unsigned data)
{

unsigned addr;
int value;

if((value = normalize(vector,data)) == -1) return 0;
if (gate >= oual_nrgates) return 0;
addr = gate * 6;
if((value < oual_rgate[addr]) || (value > oual_rgate[addr+1])) return 0;
				/* less than lower level or greater than upper level  *
return 1;       /* normalized value is within gates *
}

the above routines are included in interrp.c  as of jan 1996 /dec

*/


